/*  This is the sample program for KeyBoard Interface

    Auther : Johnny Tseng
    Date : 2000/5/27

*/


#include <dos.h>
#include <stdio.h>
#include <conio.h>

#include "pci.h"

/* set default value for ioport, CNTR */
unsigned int ioport = 0;

#define SCANH	(ioport + 0)
#define SCANV	(ioport + 1)

int KB_Scan (void)
{
  int i, j, code;

  for (i = 0; i < 5; i++) {
    outportb (SCANV,(1 << i));
    delay (1);
    code = inportb (SCANH) & 0x1f;
    if (code != 0)
      break;
  }
  for (j = 0; j < 5; j++)
    if (code & (1 << j))
      break;
  if (i < 5 && j < 5)
    return i * 5 + j;
  else
    return -1;
}

int main (void)
{
  int r, c;
  int rr = -1;

  clrscr ();
  r =  GetPCICardInfo (PCI_DEVICE_ID_2_8255, &ioport);
  if (r) {
    ioport = 0;
    cputs ("Can not find PCI 8255/8253 card.\n\r");
    return -1;
  }
  cprintf ("Channel number (1 or 2):");
  do {
    c = getch ();
  } while (c != '1' && c != '2' && c != 27);
  putch (c);
  cprintf ("\n\r");
  if (c == 27)
    return 1;
  if (c == '2')
    ioport += 4;
  outportb (ioport + 3, 0x99);
  for (;;) {
    r = KB_Scan ();
    if (r >= 0 && r != rr) {
      printf ("key=%d\n", r);
      rr = r;
    }
    else if (r < 0) {
      rr = -1;
    }
    if (kbhit ())
      break;
  }
  getch ();
  return 0;
}
