/*  This is the sample program for LCD Interface

    Auther : Johnny Tseng
    Date : 2000/5/27

*/


#include <dos.h>
#include <stdio.h>
#include <conio.h>

#include "pci.h"

/* set default value for ioport, CNTR */
unsigned int ioport = 0;

#define RESET	10
#define ENABLE 	12
#define RW	14

#define DATA	(ioport)
#define CTRL	(ioport + 3)

void LCD_SendChar (int c)
{
  outportb (CTRL, RESET + 1);
  outportb (CTRL, RW);
  outportb (DATA, c);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (1);
}


void LCD_GotoXY (int x, int y)
{
  int n;

  if (x >= 20)
    x = 20;
  if (y == 0)
    n = x;
  else if (y == 1)
    n = 64 + x;
  else if (y == 2)
    n = 20 + x;
  else
    n = 64 + 20 + x;
  outportb (CTRL, RESET);
  outportb (DATA, 128 + n);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);
}


void LCD_Clear (void)
{
}

void LCD_Init (void)
{
  outportb (ioport + 3, 0x80);

  outportb (ioport, 0);
  outportb (ioport + 1, 0);
  outportb (ioport + 2, 0);

  outportb (CTRL, ENABLE);
  outportb (CTRL, RW);
  outportb (CTRL, RESET);

  outportb (DATA, 48);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);

  outportb (DATA, 56);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);

  outportb (DATA, 12);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);

  outportb (DATA, 1);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);

  outportb (DATA, 6);
  outportb (CTRL, ENABLE + 1);
  outportb (CTRL, ENABLE);
  delay (5);
}

int main (void)
{
  int r, c;
  int line = 0;
  int ch, i, j;

  clrscr ();
  r =  GetPCICardInfo (PCI_DEVICE_ID_2_8255, &ioport);
  if (r) {
    ioport = 0;
    cputs ("Can not find PCI 8255/8253 card.\n\r");
    return -1;
  }
  cprintf ("Channel number (1 or 2):");
  do {
    c = getch ();
  } while (c != '1' && c != '2' && c != 27);
  putch (c);
  cprintf ("\n\r");
  if (c == 27)
    return 1;
  if (c == '2')
    ioport += 4;
  LCD_Init ();
  for (;;) {
    ch = getche ();
    if (ch == 13) {
      line++;
      if (line >= 4)
	line = 0;
      LCD_GotoXY (line, 0);
    }
    else if (ch == 27)
      break;
    else
      LCD_SendChar (ch);
  }
  for (i = 0; i < 4; i++)
    for (j = 0; j < 20; j++) {
      LCD_GotoXY (j, i);
      LCD_SendChar ('A'+ j);
      //printf ("%d %d\n", i, j);
      //getch ();
  }
  return 0;
}